%ifarch %{ix86}
%define target linux
%endif
%ifarch x86_64
%define target linux-64
%endif
%ifarch ppc
%define target linux-ppc
%endif

Summary: Parallel / Multiprocessor Ray Tracing System
Name: tachyon
Version: 0.97
Release: 2%{?dist}.1
URL: http://jedi.ks.uiuc.edu/~johns/raytracer/
Group: Applications/Engineering
Source: http://jedi.ks.uiuc.edu/~johns/raytracer/files/0.97/tachyon-0.97.tar.gz
Patch0: %{name}-rpm.patch
License: BSD
BuildRoot: %{_tmppath}/%{name}-%{version}-root-%(%{__id_u} -n)
BuildRequires: mesa-libGLU-devel
BuildRequires: libpng-devel
BuildRequires: libjpeg-devel
BuildRequires: lam-devel
BuildRequires: pkgconfig

%description
A portable, high performance parallel ray tracing system supporting MPI
and multithreaded implementations.  Tachyon is built as a C callable
library, which can be used with the included demo programs or within
your own application.  The distribution also includes a simple scene
file parser front-end which reads a few different formats.

This package contains pthread build.

%package gl
Summary: Parallel / Multiprocessor Ray Tracing System
Group: Applications/Engineering
Provides: %{name} = %{version}-%{release}

%description gl
A portable, high performance parallel ray tracing system supporting MPI
and multithreaded implementations.  Tachyon is built as a C callable
library, which can be used with the included demo programs or within
your own application.  The distribution also includes a simple scene
file parser front-end which reads a few different formats.

This package contains pthread build with OpenGL display.

%package lam
Summary: Parallel / Multiprocessor Ray Tracing System with OpenGL display
Group: Applications/Engineering
Provides: %{name} = %{version}-%{release}

%description lam
A portable, high performance parallel ray tracing system supporting MPI
and multithreaded implementations.  Tachyon is built as a C callable
library, which can be used with the included demo programs or within
your own application.  The distribution also includes a simple scene
file parser front-end which reads a few different formats.

This package contains LAM build.

%package lam-gl
Summary: Parallel / Multiprocessor Ray Tracing System with OpenGL display
Group: Applications/Engineering
Provides: %{name} = %{version}-%{release}

%description lam-gl
A portable, high performance parallel ray tracing system supporting MPI
and multithreaded implementations.  Tachyon is built as a C callable
library, which can be used with the included demo programs or within
your own application.  The distribution also includes a simple scene
file parser front-end which reads a few different formats.

This package contains LAM build with OpenGL display.

%package docs
Summary: Documentation and example scenes for tachyon
Group: Documentation
Requires: %{name} = %{version}-%{release}

%description docs
This package contains documentation and example scenes for rendering
with tachyon.

%prep
%setup -q -n %{name}
%patch0 -p1 -b .r
find . -name CVS | xargs %{__rm} -rf
chmod 644 src/hash.*
chmod 644 demosrc/trackball.c
chmod 644 scenes/imaps/*

%build
pushd unix
%{__make} %{?_smp_mflags} OPTFLAGS="$RPM_OPT_FLAGS" %{target}-thr
%{__make} %{?_smp_mflags} OPTFLAGS="$RPM_OPT_FLAGS" %{target}-thr-ogl
%{__make} %{?_smp_mflags} OPTFLAGS="$RPM_OPT_FLAGS" LAMHOME=%{_libdir}/lam %{target}-lam
%{__make} %{?_smp_mflags} OPTFLAGS="$RPM_OPT_FLAGS" LAMHOME=%{_libdir}/lam %{target}-lam-ogl
popd

%install
%{__rm} -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT{%{_bindir},%{_datadir}/tachyon}
for variant in -thr -thr-ogl -lam -lam-ogl ; do
  install -pm755 compile/%{target}$variant/tachyon $RPM_BUILD_ROOT%{_bindir}/tachyon$variant
done
rename -thr "" $RPM_BUILD_ROOT%{_bindir}/*
%{__rm} docs/tachyon/images.idx
%{__mv} docs/tachyon docs/html
%{__cp} -pr scenes $RPM_BUILD_ROOT%{_datadir}/tachyon/

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc Changes Copyright README
%attr(755,root,root) %{_bindir}/%{name}

%files gl
%defattr(644,root,root,755)
%doc Changes Copyright README
%attr(755,root,root) %{_bindir}/%{name}-ogl

%files lam
%defattr(644,root,root,755)
%doc Changes Copyright README
%attr(755,root,root) %{_bindir}/%{name}-lam

%files lam-gl
%defattr(644,root,root,755)
%doc Changes Copyright README
%attr(755,root,root) %{_bindir}/%{name}-lam-ogl

%files docs
%defattr(644,root,root,755)
%doc docs/tachyon.pdf docs/tachyon.ps docs/html
%{_datadir}/tachyon

%changelog
* Thu Nov 30 2006 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.97-2.fc5.1
- work around libpng bug #217903

* Wed Nov 29 2006 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.97-2
- use only kosher CFLAGS
- fix target setting

* Tue Nov 28 2006 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.97-1
- initial build
- patch to add necessary build targets
